#include "..\shared\SubMission.h"

#include <string.h>
#include "..\Shared\Taunts.h"

/*
	InstantMission

	Just add water!!
*/

// Distance from enemy recycler for enemies to be parked for siege
// mode to be triggered.
const float kfSIEGE_DISTANCE = 250.0f;
const int kiSIEGE_TIME = 45 * 10; // 45 seconds, 10 AI ticks per second

const int MAX_GOODIES=40;
// #define TEST_INSTANT 1

//const int myForce = 1;
//const int compForce = 2;
const int difficulty = 2;

//

#ifdef _DEBUG
FILE *logfpout=NULL;
static void OpenLogfile(void)
{
	if(logfpout==NULL)
		logfpout=fopen("c:\\mpinstant.txt","w");
}
#endif

// Errant scav-cleaning code. Added by Nathan Mates 7/20/01.

// Number of CPU Scavs that'll trigger a cleanup
const int MaxCPUScavs=15;

// Number of scavs (vehicles) that'll be left around after a cleanup.
const int MinCPUScavs=5;

enum AIPType {
	AIPType0=0,
	AIPType1,
	AIPType2,
	AIPType3,
	AIPTypeA,
	AIPTypeL,
	AIPTypeS,
	MAX_AIP_TYPE,
};
const char *AIPTypeExtensions="0123als"; // AIPType above is offset in this string table

char CustomAIPNameBase[256];
bool CheckedSVar3=false;

class instantMission : public SubMission {
public:
	instantMission(void)
	{
		b_count = &b_last - &b_first - 1;
		b_array = &b_first + 1;

		f_count = &f_last - &f_first - 1;
		f_array = &f_first + 1;

		h_count = &h_last - &h_first - 1;
		h_array = &h_first + 1;

		i_count = &i_last - &i_first - 1;
		i_array = &i_first + 1;
	}
//	~instantMission();

	// Based on player races and type, set AIPlan
	void SetCPUAIPlan(const int CPUSide,const int HumanSide,AIPType Type);

	// And set up extra race-specific vehicles at pathpoints in the map.
	void SetupExtraVehicles(void);

	// Builds a starting vehicle on the specified team with either ODF1
	// (preferred, if found) or ODF2 as its name, modified by the
	// race. Sets group, if specified. Returns the handle
	Handle BuildStartingVehicle(int Team, int Race, char *ODF1, char *ODF2, char *Where, int aGrp = -1);

	virtual void AddObject(Handle h,bool IsStartingVehicles, Handle *RecyclerHandles);
	virtual void DeleteObject(Handle h);
	virtual void Setup(void);
	virtual void CreateObjectives();
	virtual void TestObjectives();
	virtual void Execute(bool *TeamIsSetUp, Handle *RecyclerHandles);
	virtual void DoGenericStrategy(bool *TeamIsSetUp, Handle *RecyclerHandles);
	virtual EjectKillRetCodes PlayerEjected(void);
	virtual EjectKillRetCodes PlayerKilled(int KillersHandle);

private:
	// bools
	bool
		b_first,
		start_done,
		inspect_bunker,
		second_objective,
		picking_up[MAX_GOODIES],
		captured[MAX_GOODIES],
		siege_on,
		anti_assault,
		late_game,
		have_armory,
		SetFirstAIP,
		bIraqiMode,
		bPastAIP0, // true when they've built a recyler building, or we get bored
		bCPUBuiltCommBunker,
		b_last;

	// floats
	float
		f_first,
		f,
		f_last;

	// handles
	Handle
		h_first,
		h,
		obj1,
		bunker,
		bunker2,
		player,
		foe1,
		foe2,
		foe3,
		walker,
		tug,
		recycler,
		enemy_recycler,
		powerup1,
		powerup2,
		powerup3,
		powerup4,
		goodies[MAX_GOODIES],
		tuglist[MAX_GOODIES],  // keep track of tugs
		holding[MAX_GOODIES],
		CPUScavList[MaxCPUScavs], // List of CPU scav handles, used during cleanup.
		h_last;

	// integers
	int
		i_first,
		strat_team,
		i,
		siege_counter,
		assault_counter,
		next_wave,
		next_spawn,
		time_count,
		post_bunker,
		enemy_reinforcement_time,
		friend_reinforcement_time,
		end_counter,
		comp_team,
		powerup_counter,
		turn_counter,
		myGoal,
		mySide,
		HumanSide,
		NumHumans,
		difficulty,
		NumCPUScavs,
		TurretAISkill, // ivar17
		NonTurretAISkill, // ivar18
		CPUTurretAISkill, // ivar21
		CPUNonTurretAISkill, // ivar22
		myForce,
		compForce,
		CPUTeamRace,
		StratTeamRace,
		FirstAIPSwitchTime, // ivar26
		i_last;
};

// Sees if this is a recycler ODF, and returns the race ('a'..'z') if
// true. Returns 0 if not a recycler.
static int IsRecyclerODF(Handle h)
{
	char ODFName[64];
	GetObjInfo(h, Get_CFG, ODFName);

	if(strnicmp(ODFName+1,"vrecy",5) == 0)
		return ODFName[0];

	// fallback: not a recycler.
	return false;
}

// Builds a starting vehicle on the specified team with either ODF1
// (preferred, if found) or ODF2 as its name, modified by the
// race. Sets group, if specified. Returns the handle
Handle instantMission::BuildStartingVehicle(int aTeam, int aRace, char *ODF1, char *ODF2, char *Where, int aGrp)
{
	char TempODF[32];
	memset(TempODF,0,sizeof(TempODF));

	strncpy(TempODF,ODF1,sizeof(TempODF)-1);
	TempODF[0] = (char)aRace;
	if(!DoesODFExist(TempODF)) { // fallback to ODF2
		memset(TempODF,0,sizeof(TempODF));
		strncpy(TempODF,ODF2,sizeof(TempODF)-1);
		TempODF[0] = (char)aRace;
	}

	Handle h = BuildObject(TempODF,aTeam,Where);
	if((h != 0) && (aGrp >= 0))
		SetGroup(h,aGrp);
	return h;
}

// And set up extra race-specific vehicles at pathpoints in the map.
void instantMission::SetupExtraVehicles(void)
{
#ifndef EDITOR
	int pathCount;
	char **pathNames;
	GetAiPaths(pathCount, pathNames);

	char cCPUTeamRace = (char) CPUTeamRace;
	char cHumanTeamRace = (char) StratTeamRace;
	size_t len;

	NumCPUScavs=0; // Nothing in this list now.

	for (int i = 0; i < pathCount; ++i) {
		char *Label = pathNames[i];
		if(strncmp(Label,"mpi",3)==0) {
			// Starts with MPI. Process it.

			const int MaxODFLen=32;
			char ODF1[MaxODFLen];
			char ODF2[MaxODFLen];

			// Prezap full string contents so we don't have to null-term later
			memset(ODF1,0,sizeof(ODF1));
			memset(ODF2,0,sizeof(ODF2));

			char *pUnderscore = strchr(Label,'_');
			if(pUnderscore == NULL)
				continue; // Misformat! No _ found! Bail!

			char *pUnderscore2 = strchr(pUnderscore+1,'_');
			if(pUnderscore2 == NULL) {
				// Only 1 underscore in the name, e.g. (mpic#_ivturr). Copy
				// everything after it to the first name.
				strncpy(ODF1,pUnderscore+1,sizeof(ODF1) - 1);
			}
			else {
				// 2 underscores in the name, e.g. (mpic#_ivturr_fvturr). Copy
				// everything between them to ODF1, rest to ODF2.
				size_t len = (pUnderscore2 - pUnderscore) - 1;
				if(len > (sizeof(ODF2) - 1))
					len = (sizeof(ODF2) - 1);
				strncpy(ODF1,pUnderscore+1,len);
				strncpy(ODF2,pUnderscore2+1,sizeof(ODF2) - 1);
			}

			len = strlen(ODF1);
			if((len > 0) && (ODF1[len-1] == '_'))
				ODF1[len-1] = '\0';
			len = strlen(ODF2);
			if((len > 0) && (ODF2[len-1] == '_'))
				ODF2[len-1] = '\0';

			// For the CPU?
			if(strncmp(Label,"mpic",4)==0) {
				if(ODF1[0] == cCPUTeamRace)
					BuildObject(ODF1,comp_team,Label);
				if(ODF2[0] == cCPUTeamRace)
					BuildObject(ODF2,comp_team,Label);
			}
			else if(strncmp(Label,"mpiC",4)==0) {
				if(ODF1[0]) {
					ODF1[0]= cCPUTeamRace;
					BuildObject(ODF1,comp_team,Label);
				}
				if(ODF2[0]) {
					ODF2[0] = cCPUTeamRace;
					BuildObject(ODF2,comp_team,Label);
				}
			}
			else if(strncmp(Label,"mpih",4)==0) { // For the human side
				Handle h;
				if(ODF1[0] == cHumanTeamRace) {
					h=BuildObject(ODF1,strat_team,Label);
					SetGroup(h,4);
				}

				if(ODF2[0] == cHumanTeamRace) {
					h=BuildObject(ODF2,strat_team,Label);
					SetGroup(h,4);
				}
			}
			else if(strncmp(Label,"mpiH",4)==0) { // For the human side
				Handle h;
				if(ODF1[0]) {
					ODF1[0] = cHumanTeamRace;
					h=BuildObject(ODF1,strat_team,Label);
					SetGroup(h,4);
				}

				if(ODF2[0]) {
					ODF2[0] = cHumanTeamRace;
					h=BuildObject(ODF2,strat_team,Label);
					SetGroup(h,4);
				}
			}
		}
	}
#endif // #ifndef EDITOR
}


void instantMission::SetCPUAIPlan(const int CPUSide,const int HumanSide,AIPType Type)
{
#ifndef EDITOR
#ifdef _DEBUG
	OpenLogfile();
	fprintf(logfpout,"SetCPUAIPlan(%d, %d, %d)\n",CPUSide,HumanSide,Type);
#endif
	
	if(!CheckedSVar3) {
		CheckedSVar3=true;
		const char *Contents=GetVarItemStr("network.session.svar3");
		if((Contents == NULL) || (Contents[0] == '\0'))
			// Use the default 1.3 naming scheme if not specified.
			strncpy(CustomAIPNameBase,"stock13_",sizeof(CustomAIPNameBase)-1);
		else {
			strncpy(CustomAIPNameBase,Contents,sizeof(CustomAIPNameBase)-1);
		}
	}

	if((Type<0) || (Type >=MAX_AIP_TYPE))
		Type=AIPType3; // Default

	// Try to keep AI from getting hung up if user rushes them - NM 7/15/05
	if((Type > AIPType3) && (!bCPUBuiltCommBunker))
		return;

	char AIPFile[512];
	unsigned long l; // End of string

	// Prezap contents of string, so that we can safely append
	// characters w/o worrying about having to re-terminate
	memset(AIPFile,0,sizeof(AIPFile));

	// -16 == enough space to fit chars we add
	strncpy(AIPFile,CustomAIPNameBase,sizeof(AIPFile)-16); 

	l=strlen(AIPFile);
	// First extension char: cpu's race
	AIPFile[l++]=(char)CPUTeamRace;

	// Second extension char: human's race.
	AIPFile[l++]=(char)StratTeamRace;

	AIPFile[l++]=AIPTypeExtensions[Type];

	// Always tack on file extension
	strcat(AIPFile,".aip");
	SetPlan(AIPFile,comp_team);

	if(SetFirstAIP)
		DoTaunt(TAUNTS_Random);
	SetFirstAIP=true;
#endif // #ifndef EDITOR
}


void instantMission::Setup(void)
{
#ifndef EDITOR
	/*
		Here's where you set the values at the start.  
	*/

	static bool DidInit=false;
	if(!DidInit) {
		TurretAISkill=GetVarItemInt("network.session.ivar17");
		TurretAISkill = clamp(TurretAISkill,0,3);

		NonTurretAISkill=GetVarItemInt("network.session.ivar18");
		NonTurretAISkill = clamp(NonTurretAISkill, 0, 3);

		CPUTurretAISkill=GetVarItemInt("network.session.ivar21");
		CPUTurretAISkill = clamp(CPUTurretAISkill, 0, 3);

		CPUNonTurretAISkill=GetVarItemInt("network.session.ivar22");
		CPUNonTurretAISkill = clamp(CPUNonTurretAISkill, 0, 3);

		int StartingVehicles=GetVarItemInt("network.session.ivar7");
		bIraqiMode = (TurretAISkill == 3) && (NonTurretAISkill == 3) && 
			(CPUTurretAISkill == 0) && (CPUNonTurretAISkill == 0) && (StartingVehicles == 7);

		myForce=GetVarItemInt("network.session.ivar23");
		myForce = clamp(myForce, 0, 3);

		compForce=GetVarItemInt("network.session.ivar24");
		compForce = clamp(compForce, 0, 3);

		FirstAIPSwitchTime = GetVarItemInt("network.session.ivar26");
		if(FirstAIPSwitchTime == 0)
			FirstAIPSwitchTime = 180;
		if(FirstAIPSwitchTime > 0)
			FirstAIPSwitchTime *= 10; // convert from seconds to sim ticks
	}

	start_done=false;
	time_count=1;
	inspect_bunker=false;
	second_objective=false;
	post_bunker=1;
	enemy_reinforcement_time=2000;
	friend_reinforcement_time=2500;
	end_counter=0;
	comp_team=6;
	strat_team=0;  // the default
	obj1=(-1);

	turn_counter=0;

	
	siege_on=false;
	anti_assault=false;
	siege_counter=0;
	assault_counter=0;
	late_game=false;
	have_armory=false;
	
	powerup1=NULL;
	powerup2=NULL;
	powerup3=NULL;
	powerup4=NULL;

	for (int temp=0;temp<40;temp++)
	{
		goodies[temp]=NULL;
		picking_up[temp]=false;
		captured[temp]=false;
		tuglist[temp]=NULL;
		holding[temp]=NULL;
	}

	myGoal=2;
	NumHumans=CountPlayers();
#endif // #ifndef EDITOR
}

// Note: within this AddObject() function body, *NEVER* call
// RemoveObject(h), i.e. what was passed in. That *will* cause
// problems. If you must delete it, stash that Handle somewhere,
// and call RemoveObject next Execute() cycle.
void instantMission::AddObject(Handle h, bool IsStartingVehicles, Handle *RecyclerHandles)
{
#ifndef EDITOR
	// Always grab the ODF name out, if possible. Makes life much easier
	// in here.
	char ODFName[64];
	GetObjInfo(h, Get_CFG, ODFName);

	// Always get one random # in 0..1, for scion shield randomization
	float fRandomNum = GetRandomFloat(1.0f);

	// Need to watch this the first few turns, as we're not called
	// immediately anymore - NM 6/18/05
	if (turn_counter < 2) {
		// monitor what objects get built by the mpstrat dll
		if (GetTeamNum(h) == 1) {

			// Is this the human's recycler? If so, note it.
			int HumanRecyRace=IsRecyclerODF(h);
			if(HumanRecyRace) {
				StratTeamRace=HumanRecyRace;
				recycler = h;
				if(HumanRecyRace == 'i') {
					HumanSide=2;
					mySide = 1;
				}
				else if(HumanRecyRace == 'f') {
					HumanSide=1;
					mySide = 2;
				}
			}
			
			// Always get CPU race the first timestep also.
			int ShellRace=GetVarItemInt("network.session.ivar13");
			CPUTeamRace=ShellRace;
			if(CPUTeamRace == 'f')
				mySide=1;
			else
				mySide=2; // ISDF

#ifdef _DEBUG
				OpenLogfile();
				fprintf(logfpout,"ShellRace overrode mySide to %d\n",mySide);
				fprintf(logfpout,"StratTeamRace='%c' . CPUTeamRace='%c'\n",StratTeamRace,CPUTeamRace);
#endif

		}
	}

	// Note: this is the proper way to determine if a handle points to a
	// turret. NM 1/29/05
	char ObjClass[64];
	GetObjInfo(h, Get_GOClass, ObjClass);
	bool IsTurret = (stricmp(ObjClass, "CLASS_TURRETTANK") == 0);
	bool IsCommBunker = (stricmp(ObjClass, "CLASS_COMMBUNKER") == 0) || 
		(stricmp(ObjClass, "CLASS_COMMTOWER") == 0);
	if(IsCommBunker && (GetTeamNum(h) == comp_team))
		bCPUBuiltCommBunker = true;

	// Set skill levels for humans
	if (GetTeamNum(h)!=comp_team) {

		int UseTurretSkill=TurretAISkill;
		int UseNonTurretSkill=NonTurretAISkill;
#if 0
		if(IsStartingVehicles) {
			if(UseTurretSkill >0)
				UseTurretSkill--;  // bottoms out at zero.
			if(UseNonTurretSkill >0)
				UseNonTurretSkill--;  // bottoms out at zero.
		}
#endif

		if(IsTurret)
			SetSkill(h,UseTurretSkill);
		else
			SetSkill(h,UseNonTurretSkill);
	}

	// Also see if this is a new recycler vehicle (e.g. user upgraded
	// recycler building to vehicle)
	if(RecyclerHandles != NULL) {
		bool IsRecyVehicle = (stricmp(ObjClass, "CLASS_RECYCLERVEHICLE") == 0);
		if(IsRecyVehicle) {
			int Team = GetTeamNum(h);
			// If we're not tracking a recycler vehicle for this team right
			// now, store it.
			if(RecyclerHandles[Team] == 0)
				RecyclerHandles[Team] = h;
		}
	}

	// CPU unit added. Do stuff.
	if (GetTeamNum(h)==comp_team)
	{

		int UseTurretSkill=CPUTurretAISkill;
		int UseNonTurretSkill=CPUNonTurretAISkill;
		if(IsStartingVehicles) {
			if(UseTurretSkill >0)
				UseTurretSkill--;  // bottoms out at zero.
			if(UseNonTurretSkill >0)
				UseNonTurretSkill--;  // bottoms out at zero.
		}

		if(IsTurret)
			SetSkill(h,UseTurretSkill);
		else
			SetSkill(h,UseNonTurretSkill);

		if(bIraqiMode) {
			// Nerf CPU team for quick testing.
			SetCurHealth(h,1);
			SetCurAmmo(h,1);
			SetMaxHealth(h,1);
			SetMaxAmmo(h,1);
			SetSkill(h,0);
		}

		// Better way to identify scavs added NM 1/29/05 -- checks for
		// regular & hoverscavs, no matter what their ODF is named.
		char ObjClass[64];
		GetObjInfo(h, Get_GOClass, ObjClass);

		if((stricmp(ObjClass, "CLASS_SCAVENGER") == 0) || (stricmp(ObjClass, "CLASS_SCAVENGERH") == 0)) {
			// Ok, adding in another scav. Add to list (and don't trash
			// memory) This is a fast operation in all cases.
			if(NumCPUScavs<MaxCPUScavs)
				CPUScavList[NumCPUScavs++] = h;

			// Cleanup time? This cleanup is only triggered when the list
			// gets too big, so there's no drag on performance. 
			if(NumCPUScavs>=MaxCPUScavs) {
				int i,j;

				DoTaunt(TAUNTS_Random);

				for(i=0,j=0;i<MaxCPUScavs;i++) {
					// Because we don't track the cases where scavs could
					// disappear from our list (destroyed, sniped, deployed), we
					// need to verify that it's still a vehicle scav on the same
					// team as it started on before we even consider destroying
					// it. If it doesn't meet those conditions, we no longer
					// need to keep track of it, as it's not a concern anymore.
					//
					// The oldest MinCPUScavs get to live. (CPUScavList[0] is
					// the oldest scav). Theoretically, the oldest scavs are the
					// furthest from the recycler, so killing them shouldn't
					// affect the gameplay too much. You could probably improve
					// this algorithm by keeping, say 10-15 scavs, that are more
					// than 150 meters from the recycler. That is left as an
					// exercise for the reader. :)

					if(IsAround(CPUScavList[i]) && (GetTeamNum(CPUScavList[i])==comp_team)) {

						// Still should be in the list. Keep it, or destroy?
						if((j<MinCPUScavs) || (h == CPUScavList[i]))
							CPUScavList[j++]=CPUScavList[i];
						else {
							// Don't generate a scrapfield the AI might try and
							// build more scavs to pick up and loop infinitely.
							SetNoScrapFlagByHandle(CPUScavList[i]);
							RemoveObject(CPUScavList[i]);
						}
					}
				} // Loop over all scavs in the CPUScavList[] array.

				// Note how many scavs there are now. This may be smaller than
				// MinCPUScavs if it's decided they don't need to be tracked
				// anymore (see criteria above)
				NumCPUScavs=j;

				// Clean up rest of list. [A bunch of 0s compress better when
				// transmitting across the network. Not that this is going to
				// kill the netcode to not do this, but I like doing this
				// anyhow.]
				for(i=NumCPUScavs;i<MaxCPUScavs;i++)
					CPUScavList[i]=0;

			} // Cleanup time triggered.
		} // ivscav or fvscav has was just created
		// end scav cleanup code. 

		// Changed NM 10/19/01 - all AI is at skill 3 now by default (at top of this function)
		//		SetSkill(h,difficulty+1);

		/*
		if (//(!IsAlive(h)) && 
			((IsOdf(h,"fvtank")) || (IsOdf(h,"fvarch"))))
		{
			for (int temp=0;temp<MAX_GOODIES;temp++)
			{
				if (goodies[temp]==NULL)
				{
					goodies[temp]=h;
					break;
				}
			}
		}
		*/
		if ((IsOdf(h,"ibarmo")) || (IsOdf(h,"fbstro"))) {
			have_armory=true;
		}
		if (have_armory) {
			if(strnicmp(ODFName,"ivtank",6) == 0) {
				GiveWeapon(h,"gspstab_c");
			}
			if(strnicmp(ODFName,"fvtank",6) == 0) {
				GiveWeapon(h,"garc_c");   // what a crutch!  
				//				GiveWeapon(h,"gshield");
			}

			// Randomize shields somewhat. - NM 5/24/03
			if(strnicmp(ODFName,"fv",2) == 0) {
				if(fRandomNum < 0.3f)
					GiveWeapon(h,"gshield");
				else if(fRandomNum < 0.6f)
					GiveWeapon(h,"gabsorb");
				else if(fRandomNum < 0.9f)
					GiveWeapon(h,"gdeflect");
			}
		}
	} // Computer team.
	else
	if ((myGoal==0) && (GetTeamNum(h)==strat_team))
	{

		// if it's artillery bomber/ go to late game tactics
		if((strnicmp(ODFName,"fvartl",6) == 0) ||
			 (strnicmp(ODFName,"ivbomb",6) == 0)) {
			if ((!siege_on) && (!late_game)) {
				late_game=true;
				SetCPUAIPlan(mySide,HumanSide,AIPTypeL);
			}
		}

		// Um, what's this code supposed to be doing? Turned off for now -
		// NM 9/9/02
// 		if (( strnicmp(ODFName,"ivscout",7) == 0) 
// 			|| (strnicmp(ODFName,"ivmisl" ,6) == 0)
// 			|| (strnicmp(ODFName,"ivtank" ,6) == 0)
// 			|| (strnicmp(ODFName,"ivrckt" ,6) == 0)
// 			|| (strnicmp(ODFName,"ivatank",7) == 0)
// 			|| (strnicmp(ODFName,"ivwalk" ,6) == 0)
// 			|| (strnicmp(ODFName,"ivserv" ,6) == 0)
// 			|| (strnicmp(ODFName,"fvscout",7) == 0) 
// 			|| (strnicmp(ODFName,"fvsent" ,6) == 0)
// 			|| (strnicmp(ODFName,"fvtank" ,6) == 0)
// 			|| (strnicmp(ODFName,"fvarch" ,6) == 0)
// 			|| (strnicmp(ODFName,"fvatank",7) == 0)
// 			|| (strnicmp(ODFName,"fvwalk" ,6) == 0)
// 			|| (strnicmp(ODFName,"fvserv" ,6) == 0)
// 		)
// 		{
// 			// Changed NM 10/19/01 - all AI is at skill 3 now by default (at top of this function)
// 			//			SetSkill(h,3-difficulty);

// 			SetTeamNum(h,1);
// 			//			int grp=GetFirstEmptyGroup();			
// 			//			SetGroup(h,grp);
// 		}

	}
	if (GetTeamNum(h)==strat_team) {
	
		if (strnicmp(ODFName+1,"brecy",5) == 0) {
			if(!bPastAIP0) {
				bPastAIP0 = true;
				/*
					SetAip here based on turn_counter
				*/

				int stratchoice = turn_counter%2;
				if (mySide==1) {
					//				stratchoice = turn_counter%3; // Seems to give problems - NM 7/5/03
					switch (stratchoice) {
					default:
					case 0:
#ifdef TEST_INSTANT
						SetObjectiveOn(h);
						SetObjectiveName(h,"scioninst1");
#endif
						SetCPUAIPlan(mySide,HumanSide,AIPType1);
						break;
					case 1:
#ifdef TEST_INSTANT
						SetObjectiveOn(h);
						SetObjectiveName(h,"scioninst3");
#endif
						SetCPUAIPlan(mySide,HumanSide,AIPType3);
						break;
					case 2:
#ifdef TEST_INSTANT
						SetObjectiveOn(h);
						SetObjectiveName(h,"scioninst2");
#endif
						SetCPUAIPlan(mySide,HumanSide,AIPType2);
						break;
					}
				}
				else {
					switch (stratchoice) {
					default:
					case 0:
#ifdef TEST_INSTANT
						SetObjectiveOn(h);
						SetObjectiveName(h,"isdfinst1");
#endif
						SetCPUAIPlan(mySide,HumanSide,AIPType1);
						break;
					case 1:
#ifdef TEST_INSTANT
						SetObjectiveOn(h);
						SetObjectiveName(h,"isdfinst3");
#endif
						SetCPUAIPlan(mySide,HumanSide,AIPType3);
						break;
					}
	
				}
			} // not past AIP0
		} else {
			if((strnicmp(ODFName+1,"vatank",6) == 0) ||
				 (strnicmp(ODFName+1,"vwalk",5) == 0))
				assault_counter++;
		}
	} // on strat team

	if((!bPastAIP0) && (FirstAIPSwitchTime > 0) && (turn_counter > FirstAIPSwitchTime)) {
		bPastAIP0 = true;
		int stratchoice = turn_counter%2;
		switch (stratchoice % 2) {
		default:
		case 0:
			SetCPUAIPlan(mySide,HumanSide,AIPType1);
			break;
		case 1:
			SetCPUAIPlan(mySide,HumanSide,AIPType3);
			break;
		}
	}
#endif // #ifndef EDITOR
}

void instantMission::DeleteObject(Handle h)
{
#ifndef EDITOR
	if (GetTeamNum(h)==strat_team) {
		char ODFName[64];
		GetObjInfo(h, Get_CFG, ODFName);
		// unit exists. Check skipping race name, and any suffix
		if((strnicmp(ODFName+1,"vatank",6) == 0) ||
			 (strnicmp(ODFName+1,"vwalk",5) == 0))
			assault_counter--;
	}
	else {
		// CPU team.
		if ((IsOdf(h,"ibarmo")) || (IsOdf(h,"fbstro"))) {
			have_armory=false;
		}
	}
#endif // #ifndef EDITOR
}

void instantMission::CreateObjectives()
{
}

void instantMission::TestObjectives()
{
	// game end conditions will be handled by the strat code
}

void instantMission::Execute(bool *TeamIsSetUp, Handle *RecyclerHandles)
{
	player=GetPlayerHandle();
	turn_counter++;
	DoGenericStrategy(TeamIsSetUp, RecyclerHandles);

	// Any humans not on the right team? Make life hell for them.
	if((turn_counter % 100) == 0) {

		int i;
		for(i=0; i<MAX_TEAMS; i++) {
			Handle h = GetPlayerHandle(i);
			if(h) {
				int Grp = WhichTeamGroup(i);
				if(Grp != 0) {
					Damage(h,(1<<28)+1);
					AddToMessagesBox("MPI is limited to 5 humans! No joining the CPU team!");
				}
			}
		}
	}

}



int Rand(void)
{
	return (int)GetRandomFloat(32768);
}

void instantMission::DoGenericStrategy(bool *TeamIsSetUp, Handle *RecyclerHandles)
{
#ifndef EDITOR
//#ifdef BLAHXBLAH
//	int a;
 	time_count++;
	// Must wait for Human's recycler to be created before we have
	// everything ready to go. - NM 6/18/05
	if ((!start_done) && StratTeamRace)
	{
		strat_team=1;
		//		StratTeamRace=GetRaceOfTeam(strat_team);

		start_done=true;

		SetupExtraVehicles();
		
		// Build initial items for CPU team based on selections. The first
		// ODF listed is preferred, the second one really should be there
		// as a fallback

		// Build recycler, if it's not preplaced on the map.
		enemy_recycler = GetObjectByTeamSlot(comp_team, DLL_TEAM_SLOT_RECYCLER);
		if(enemy_recycler == 0) {
			enemy_recycler = BuildStartingVehicle(comp_team,CPUTeamRace,"*vrecycpu","*vrecy","RecyclerEnemy");
		}
		RecyclerHandles[comp_team] = enemy_recycler;
		TeamIsSetUp[comp_team]=true;

		BuildStartingVehicle(comp_team,CPUTeamRace,"*vturr","*vturr","turretEnemy1");
		BuildStartingVehicle(comp_team,CPUTeamRace,"*vturr","*vturr","turretEnemy2");

		if (compForce>0) {
			BuildStartingVehicle(comp_team,CPUTeamRace,"*bspir","*vturr","gtow2");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*bspir","*vturr","gtow3");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vsent","*vscout","SentryEnemy1");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vsent","*vscout","SentryEnemy2");
		}
		if (compForce>1) {
			BuildStartingVehicle(comp_team,CPUTeamRace,"*bspir","*vturr","gtow4");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*bspir","*vturr","gtow5");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vtank","*vtank","tankEnemy1");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vtank","*vtank","tankEnemy2");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vtank","*vtank","tankEnemy3");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vtank","*vtank","TankEnemy3");
			BuildStartingVehicle(comp_team,CPUTeamRace,"*vsent","*vscout","SentryEnemy3");
		}
		BuildStartingVehicle(comp_team,CPUTeamRace,"*vscav","*vscav","ScavengerEnemy");

// 		int grp=GetFirstEmptyGroup();			
// 		SetGroup(recycler,grp);
		if (myGoal==0)
		{
			// check my team..
			if (HumanSide==2) {
				SetPlan("isdfteam.aip",strat_team);
			}
			else
			{
				SetPlan("scionteam.aip",strat_team);
			}	
		}

		SetCPUAIPlan(mySide,HumanSide,AIPType0);
		// do enemies
		//					ClearObjectives();
		//					AddObjective("isdf0501.otf",WHITE,5.0f);

		// because turrets suck
//		BuildObject("fvscout",comp_team,"turretEnemy1");
		if (compForce>0)
		{
			if (mySide==1) { // CPU is Scion
				BuildObject("fvtank",comp_team,"TankEnemy1");
				BuildObject("fvtank",comp_team,"TankEnemy2");
				BuildObject("fvsent",comp_team,"SentryEnemy1");
				BuildObject("fvsent",comp_team,"SentryEnemy2");
				if (compForce>1) {
					BuildObject("fvtank",comp_team,"TankEnemy3");
					BuildObject("fvsent",comp_team,"SentryEnemy3");	
				}
			}
			else { // CPU is ISDF
				BuildObject("ivtank",comp_team,"TankEnemy1");
				BuildObject("ivtank",comp_team,"TankEnemy2");
				BuildObject("ivscout",comp_team,"SentryEnemy1");
				BuildObject("ivscout",comp_team,"SentryEnemy2");
				if (compForce>1) {
					BuildObject("ivtank",comp_team,"TankEnemy3");
					BuildObject("ivscout",comp_team,"SentryEnemy3");	
				}
			}
		}

		//		BuildObject("ivscout",strat_team,"Scout1");
		//		BuildObject("ivscout",strat_team,"Scout2");
		//		BuildObject("ivscout",strat_team,"Scout3");
		//		BuildObject("ivscav",strat_team,"Scavenger");

		if (mySide==1) // CPU is Scion
			BuildObject("fvscav",comp_team,"ScavengerEnemy");
		else
			BuildObject("ivscav",comp_team,"ScavengerEnemy");

		// power ups?
		BuildObject("apammo",0,"ammo1");
		BuildObject("apammo",0,"ammo2");
		BuildObject("apammo",0,"ammo3");
		BuildObject("aprepa",0,"repair1");
		BuildObject("aprepa",0,"repair2");
		BuildObject("aprepa",0,"repair3");
		// objectives .. later make this optional	
//		CreateObjectives();
		SetScrap(comp_team,60);
		SetScrap(1,40);
	}	
	if (time_count%enemy_reinforcement_time==0)
	{
//		AddScrap(comp_team,5);
		if (compForce>0)
		{
//			BuildObject("fvtank",comp_team,"TankEnemy1");
//			BuildObject("fvtank",comp_team,"TankEnemy2");
//			BuildObject("fvsent",comp_team,"SentryEnemy1");
//			BuildObject("fvsent",comp_team,"SentryEnemy2");
//			AddScrap(comp_team,10);
			if (compForce>1)
			{
//				BuildObject("fvtank",comp_team,"TankEnemy3");
//				BuildObject("fvsent",comp_team,"SentryEnemy3");	
				AddScrap(comp_team,10);
			}
		}
	}

	if ((time_count%100)==0) { // Evaluate this every 10 seconds
		NumHumans=CountPlayers();
	}

	// Avoid divide by zero if we set compforce to 3.
	int CompForceSkew=compForce*10;
	if(CompForceSkew >= 30)
		CompForceSkew=28;

	if((time_count % (30-CompForceSkew)) ==0)  // this speeds up resources
		AddScrap(comp_team,1);
	if (time_count%(11-NumHumans)==0)
		AddScrap(comp_team,1);
	if ((myForce) && (time_count%(100-(myForce*20))==0))
		AddScrap(strat_team,1);

	/*

		// An extra scrap boost? Why/how is this needed NM 3/5/02

	CompForceSkew=(compForce*10)-NumHumans+1;
	if(CompForceSkew >= 30)
		CompForceSkew=28;

	if (time_count%(30-CompForceSkew)==0)  // this speeds up resources
		AddScrap(comp_team,1);
	*/

	//	if (time_count%(100-(myForce*20))==0)
	//		AddScrap(strat_team,1);
	if (time_count%friend_reinforcement_time==0)
	{
/*
		BuildObject("ivtank",strat_team,"Tank1");
		BuildObject("ivtank",strat_team,"Tank2");
		BuildObject("ivtank",strat_team,"Tank3");
		BuildObject("ivturr",strat_team,"Turret1");
		BuildObject("ivturr",strat_team,"Turret2");
		BuildObject("ivturr",strat_team,"Turret3");
		BuildObject("ivscout",strat_team,"Scout1");
		BuildObject("ivscout",strat_team,"Scout2");
		BuildObject("ivscout",strat_team,"Scout3");
*/
		// power ups?
		BuildObject("apammo",0,"ammo1");
		BuildObject("apammo",0,"ammo2");
		BuildObject("apammo",0,"ammo3");
		BuildObject("aprepa",0,"repair1");
		BuildObject("aprepa",0,"repair2");
		BuildObject("aprepa",0,"repair3");

	}


	if (myGoal==0) {
		powerup_counter++;
		if (powerup_counter%200==0) {
			if (!IsAround(powerup1)) {
				powerup1=BuildObject("apshdw",0,"power1");
			}
			if (!IsAround(powerup2)) {
				powerup2=BuildObject("apsstb",0,"power2");
			}
			if (!IsAround(powerup3)) {
				powerup3=BuildObject("apffld",0,"power3");
			}
			if (!IsAround(powerup4)) {
				powerup4=BuildObject("apspln",0,"power4");
			}
		}
	}

	// Unified code to determine closest enemy handle, distance to CPU
	// recycler or factory (if recy dead)
	Handle ClosestEnemy = 0;
	float ClosestEnemyDist = 1e30f; // big distance!
		
	// Find nearest enemy to recycler/factory (in that order)
	Handle RecyH = GetObjectByTeamSlot(comp_team,DLL_TEAM_SLOT_RECYCLER);
	if(RecyH) {
		ClosestEnemy=GetNearestEnemy(RecyH);
		
		if(ClosestEnemy != 0) {
			char ObjClass[64];
			GetObjInfo(ClosestEnemy, Get_GOClass, ObjClass);
		
			// We want to ignore scavs that happen to drive near the CPU
			// recycler.  We're not in a siege if that's the case.
			if((stricmp(ObjClass, "CLASS_SCAVENGER") == 0) || (stricmp(ObjClass, "CLASS_SCAVENGERH") == 0)) {
				ClosestEnemy = 0;
			}


		} // ClosestEnemy exists
	} // recycler exists

	if(ClosestEnemy != 0) {
		// RecyH must be not-0 to get in here, see above.
		ClosestEnemyDist = GetDistance(ClosestEnemy,RecyH);
	}
	else {
		// Recyler doesn't exist, or closest to recycler is a scav. Check
		// around factory
		ClosestEnemy = 0; // redundant, but makes logic easier to follow
		Handle FactoryH = GetObjectByTeamSlot(comp_team,DLL_TEAM_SLOT_FACTORY);
		if(FactoryH) {
			ClosestEnemy=GetNearestEnemy(FactoryH);

			if(ClosestEnemy != 0) {
				char ObjClass[64];
				GetObjInfo(ClosestEnemy, Get_GOClass, ObjClass);
				
				// We want to ignore scavs that happen to drive near the CPU
				// recycler.  We're not in a siege if that's the case.
				if((stricmp(ObjClass, "CLASS_SCAVENGER") == 0) || (stricmp(ObjClass, "CLASS_SCAVENGERH") == 0)) {
					ClosestEnemy = 0;
				}
			} // ClosestEnemy exists
		} // FactoryH exists

		if(ClosestEnemy != 0) {
			// RecyH must be not-0 to get in here, see above.
			ClosestEnemyDist = GetDistance(ClosestEnemy,FactoryH);
		} // Have ClosestEnemy
	} // Factory check

	// AIP switch logic
	if (!siege_on) {
		if((ClosestEnemy) && (ClosestEnemyDist < kfSIEGE_DISTANCE)) { // under siege
			siege_counter++;
		} else {
			siege_counter=0;
		}
			
		if (siege_counter > kiSIEGE_TIME) { // 45 sec, if we don't change the sim rate :-)
			siege_on=true;
			SetCPUAIPlan(mySide,HumanSide,AIPTypeS);
		}
	}  // !siege_on
	else {
		// siege_on mustbe true to get here.
		if((ClosestEnemy) && (ClosestEnemyDist > kfSIEGE_DISTANCE)) { // under siege
			//			SetPlan("scioninstl.aip",comp_team);
			siege_on=false;

			SetCPUAIPlan(mySide,HumanSide,AIPTypeL);
		}
	}  // siege_on

	// assault_test
	if ((!late_game) && (!siege_on) && (!anti_assault) && (assault_counter>2)) {
		anti_assault=true;

		SetCPUAIPlan(mySide,HumanSide,AIPTypeA);
	} else {
		if ((anti_assault) && (assault_counter<3)) {
			anti_assault=false;
			SetCPUAIPlan(mySide,HumanSide,AIPTypeL);
		}
	}

	TestObjectives();
#endif // #ifndef EDITOR
}

EjectKillRetCodes instantMission::PlayerEjected(void)
{
	return DoEjectPilot;

}


EjectKillRetCodes instantMission::PlayerKilled(int KillersHandle)
{
	return DoEjectPilot;  // Game over, man.
}

SubMission * BuildSubMission(void)
{
	return new instantMission();
}

